/**
  Definition to play with a CANVAS and a ball 
  
  Fraga 03/10/2000
**/

#ifndef CANVAS_H
#define CANVAS_H

#include <qwidget.h>


class Canvas: public QWidget
{
	Q_OBJECT
public:
	enum    State { Init, Playing };
	enum    Movement { Left, Right };
	Canvas( QWidget *parent=0, const char *name=0 );

	void InitState( void );

	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *width, int *height ) { *width = w; *height = h; }
	QSizePolicy sizePolicy() const;

public slots:
	void stopMove( void ) { 
		killTimers( );
		st = Init;
	}
	void startMove( void ) { 
		startTimer( time );
		st = Playing;
	}

signals:
    void changePos( ); // called when mouse in moved
    void changeSize( ); // called when windows is resized
public: // until we have keyboard focus, should be protected
	void keyPressEvent( QKeyEvent *e );
protected:
	void paintEvent( QPaintEvent * );
	void mouseMoveEvent( QMouseEvent * );
	void resizeEvent( QResizeEvent * );
	void timerEvent( QTimerEvent  * );

private:
	State st;		 
	Movement mv;
	int w, h;        // canvas width and height 
	int xact, yact;  // Initial coordinates (the origin)
	int xnew, ynew;  // Actual (rounded) turtle position 
    double ang;		 // Ball angle

	int time;        // time for timer event
	int xmouse, ymouse;  // Mouse pointer coordinates
};


#endif // CANVAS_H

